# !/bin/sh

. ./setEnv.sh

echo "Compiling the OpenJGraph library and placing the classes under classes/ ..."
rm -rf classes/
mkdir classes
$JAVA_BIN/javac -deprecation -g -sourcepath . -classpath $CLASSPATH -d classes/ \
	salvo/jesus/graph/*.java \
	salvo/jesus/graph/listener/*.java \
	salvo/jesus/graph/adaptor/*.java \
	salvo/jesus/graph/algorithm/*.java \
	salvo/jesus/graph/java/awt/*.java \
	salvo/jesus/graph/java/awt/geom/*.java \
	salvo/jesus/graph/javax/swing/*.java \
	salvo/jesus/util/*.java \
	salvo/jesus/geom/*.java \
	salvo/jesus/graph/visual/*.java \
	salvo/jesus/graph/visual/layout/*.java \
	salvo/jesus/graph/visual/drawing/*.java \
	salvo/jesus/graph/xml/*.java \
	test/*.java

echo
echo "Copying image files..."
mkdir classes/salvo/jesus/graph/visual/images
cp -vf salvo/jesus/graph/visual/images/* classes/salvo/jesus/graph/visual/images 

echo "Copying XGMML DTD file..."
cp -vf salvo/jesus/graph/xml/*.dtd classes/salvo/jesus/graph/xml

echo
echo "Compiling sample applications..."
$JAVA_BIN/javac -g -deprecation -sourcepath . -classpath $CLASSPATH -d classes/ examples/*.java

echo
echo "Creating JAR file..."
rm -rf dist/
mkdir dist
$JAVA_BIN/jar cvf dist/openjgraph.jar -C classes/ . 

cp LICENSE.* dist/
cp lib/*.jar dist/
