#!/bin/sh

# -------------------- IMPORTANT! -----------------------------
#
# Modify the following environment variables to match your environment:
#	JAVA_BIN
#	LOG4J_LIBPATH
#	XERCES_CLASSPATH
#
# -------------------------------------------------------------

# ==================== JAVA ===================================
#JAVA_BIN=/opt/jdk1.3.1/bin 
JAVA_BIN=/usr/local/j2sdk1.4.1/bin
if [ "X"$JAVA_HOME != "X" ]; then
	JAVA_BIN=$JAVA_HOME/bin
fi
export JAVA_BIN

# ==================== LOG4J ==================================
# Setup CLASSPATH to include Apache Jakarta's Log4J libraries.
LOG4J_CLASSPATH=lib/log4j-core.jar:lib/log4j.jar

# Include the log4j.properties file we have in etc/
LOG4J_CLASSPATH=$LOG4J_CLASSPATH:etc/

# ==================== ANT ==================================
export ANT_HOME=$PWD
export PATH=$PATH:$ANT_HOME/bin

# ==================== XERCES =================================
XERCES_CLASSPATH=lib/xerces.jar

# ==================== JUNIT ==================================
JUNIT_CLASSPATH=lib/junit.jar

# ==================== OPENJGRAPH =============================
OPENJGRAPH_CLASSPATH=classes/



CLASSPATH=$OPENJGRAPH_CLASSPATH:$LOG4J_CLASSPATH:$XERCES_CLASSPATH:$JUNIT_CLASSPATH
export CLASSPATH

echo CLASSPATH is $CLASSPATH
echo
